;-----------------------------------------
;-- PEACH-Ipu[gXgbv[_	--
;--					--
;-- XMODEM$D000`̗̈ɏ	--
;-- xN^̓t@C̐擪+$A`$F	--
;-- ̗̈ɃZbgĂ		--
;-- IxN^$FF0A`$FFFF	--
;-- ɃRs[A$D000ɃWv	--
;-----------------------------------------
.segment	"ZEROPAGE"
_pt:	.word	0
_dt:	.word	0

.segment	"CODE"

	SOH = $01
	EOT = $04
	ACK = $06
	NAK = $15
	CAN = $18

	SIO_THR = $8000
	SIO_RBR = $8000
	SIO_IER = $8001
	SIO_FCR = $8002
	SIO_LCR = $8003
	SIO_LSR = $8005
	SIO_DLL = $8000
	SIO_DLM = $8001

	LSR_DR	= $01


startup:
	ldx	#$ff
	txs			; STKreg = 0xff;

	stz	SIO_IER		; SIO_IER = 0;
	stz	SIO_FCR		; SIO_FCR = 0;
	lda	#$06
	sta	SIO_FCR		; SIO_FCR = 0x06
	stz	SIO_FCR		; SIO_FCR = 0;
	lda	#33
	sta	SIO_DLL		; SIO_DLL = 33
	stz	SIO_DLM		; SIO_DLM = 0;
	lda	#$07
	sta	SIO_LCR		; SIO_LCR = 0x07
	lda	#$3
	sta	SIO_IER		; SIO_IER = 0;
jchk:				; while(1) {
	lda	SIO_LSR		;
	and	#LSR_DR		;
	beq	jchk_ok		;	if(!(SIO_LSR & LSR_DR)) break;
	lda	SIO_RBR		;	Areg = SIO_RBR
	bra	jchk		; }
jchk_ok:			; while(1) {
	lda	#NAK
	sta	SIO_THR		;	SIO_THR = NAK;
	ldx	#$00		; 	Xreg = 0;
	ldy	#$FF		;	Yreg = $ff
wait_soh:			;	while(1) {
	lda	SIO_LSR		;
	and	#LSR_DR		;
	beq	L1		;		if (SIO_LSR & LSR_DR) {
	lda	SIO_RBR		;
	cmp	#SOH		;			if (SIO_RBR == SOH)
	beq	wait_soh_done	; 				goto wait_soh_done
L1:				;		}
	dex			;
	bne	wait_soh	;		if (--Xreg != 0) continue;
	dey			;		if (--Yreg != 0) continue;
	bne	wait_soh	;		break;
L2:				;	}
	bra	jchk_ok		;}
wait_soh_done:
	stz	_pt		;
	lda	#$d0		;
	sta	_pt+1		; pt = (unsigned char *)0xd000;
frameloop:			; do {
	jsr	_xgetsio	; 	_xgetsio();	// BLK#
	jsr	_xgetsio	; 	_xgetsio();	// -BLK#
	ldy	#$80		; 	Yreg = 0x80;
datloop:			; 	do {
	jsr	_xgetsio	;		Areg = _xgetsio();
	sta	(_pt)		;		*pt = Areg
	inc	_pt		;
	bne	notover		;
	inc	_pt+1		;		pt++;
notover:			;
	dey			; 		Yreg--;
	bne	datloop		; 	} while(Yreg != 0);
	jsr	_xgetsio	; 	_xgetsio();		// CHKSUM
	lda	#ACK
	sta	SIO_THR		;	SIO_THR = ACK;
	jsr	_xgetsio	;	Areg = _xgetsio();
	cmp	#SOH		;
	beq	frameloop	; } while (Areg == SOH);

	lda	#ACK
	sta	SIO_THR		;	SIO_THR = ACK;

	lda	#$0a		;
	sta	_pt		;
	lda	#$d0		;
	sta	_pt+1		; pt = (unsigned char *)0xd00a;
	lda	#$fa		;
	sta	_dt		;
	lda	#$ff		;
	sta	_dt+1		; dt = (unsigned char *)0xfffa;
	ldx	#6		; Xreg = 0x6;
vcploop:			; do {
	lda	(_pt)
	sta	(_dt)		;	*dt = *pt;
	inc	_pt		;	pt++;
	inc	_dt		;	dt++;
	dex			;	Xreg--;
	bne	vcploop		; } while (Xreg != 0);
	jmp	$D000		; Good Luck!

_xgetsio:			;xgetsio() {
	lda	SIO_LSR		; do {
	and	#LSR_DR		;
	beq	_xgetsio	; } while(!(SIO_LSR & LSR_DR));
	lda	SIO_RBR		;
	rts			; return(SIO_RBR); }

.segment       	"VECTORS"
vector_nmi:
	.addr	startup
vector_reset:
	.addr	startup
vector_irqb:
	.addr	startup

